## blaspp 2023.11.05

=== CMakeLists.txt ===
# Copyright (c) 2017-2023, University of Tennessee. All rights reserved.
# SPDX-License-Identifier: BSD-3-Clause
# This program is free software: you can redistribute it and/or modify it under
# the terms of the BSD 3-Clause license. See the accompanying LICENSE file.
#
# CMake script for BLAS++ library.

cmake_minimum_required( VERSION 3.17 )
# 3.1  target_compile_features
# 3.8  target_compile_features( cxx_std_17 )
# 3.14 install( LIBRARY DESTINATION lib ) default
# 3.15 $<$COMPILE_LANG_AND_ID  # optional
# 3.15 message DEBUG, string REPEAT
# 3.17 find_package( CUDAToolkit )

project(
    blaspp
    VERSION 2023.11.05
    LANGUAGES CXX
)

include( CheckCXXCompilerFlag )

# When built as a sub-project, add a namespace to make targets unique,
# e.g., `make tester` becomes `make blaspp_tester`.
if (CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set( blaspp_is_project true )
    set( blaspp_ "" )
else()
    set( blaspp_is_project false )
    set( blaspp_ "blaspp_" )
endif()

#-------------------------------------------------------------------------------
# Options
if (blaspp_is_project)
    set( log "" CACHE STRING "Shorthand for CMAKE_MESSAGE_LOG_LEVEL" )
    set_property( CACHE log PROPERTY STRINGS
                  FATAL_ERROR SEND_ERROR WARNING AUTHOR_WARNING DEPRECATION
                  NOTICE STATUS VERBOSE DEBUG TRACE )
    if (log)
        set( CMAKE_MESSAGE_LOG_LEVEL "${log}" )
    endif()
endif()

option( BUILD_SHARED_LIBS "Build shared libraries" true )
option( build_tests "Build test suite" "${blaspp_is_project}" )
option( color "Use ANSI color output" true )
option( use_cmake_find_blas "Use CMake's find_package( BLAS ) rather than the search in BLAS++" false )
option( use_openmp "Use OpenMP, if available" true )

set( gpu_backend "auto" CACHE STRING "GPU backend to use" )
set_property( CACHE gpu_backend PROPERTY STRINGS
              auto cuda hip sycl none )

# After color.
include( "cmake/util.cmake" )

# Recognize CTest's BUILD_TESTING flag. (Quotes required.)
if (NOT "${BUILD_TESTING}" STREQUAL "")
    set( build_tests "${BUILD_TESTING}" )
endif()

# Default prefix=/opt/slate
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT
    AND blaspp_is_project)

    set( prefix "/opt/slate" CACHE PATH "Shorthand for CMAKE_INSTALL_PREFIX" )
    set( CMAKE_INSTALL_PREFIX "${prefix}"
         CACHE PATH
         "Install path prefix, prepended onto install directories."
         FORCE
    )
    message( STATUS "Setting CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}" )
    # Append the new CMAKE_INSTALL_PREFIX, since CMake appended the old value.
    # This helps find TestSweeper.
    list( APPEND CMAKE_SYSTEM_PREFIX_PATH ${CMAKE_INSTALL_PREFIX} )
else()
    message( STATUS "Using CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}" )
endif()

# Provide menu of options. (Why doesn't CMake do this?)
set_property( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
              None Debug Release RelWithDebInfo MinSizeRel )

# Provide menu of options.
set( BLA_VENDOR "" CACHE STRING
     "BLAS Vendor for use in CMake's FindBLAS / FindLAPACK. If empty, use BLAS++ search. Some obsolete options are omitted here." )
set_property(
    CACHE BLA_VENDOR PROPERTY STRINGS
    "" All Goto OpenBLAS FLAME ATLAS IBMESSL
    Intel10_32 Intel10_64lp Intel10_64lp_seq Intel10_64ilp Intel10_64ilp_seq
    Intel10_64_dyn Apple NAS Arm Arm_mp Arm_ilp64 Arm_ilp64_mp Generic )

#-----------------------------------
# BLAS options
# todo: Goto, BLIS, FLAME, others?
set( blas "auto" CACHE STRING
     "BLAS library to search for" )
set_property(
    CACHE blas PROPERTY STRINGS
    "auto" "Apple Accelerate" "Cray LibSci" "IBM ESSL"
    "Intel MKL" "OpenBLAS" "AMD ACML" "generic" )

set( blas_fortran "auto" CACHE STRING
     "For Intel MKL: use Intel ifort or GNU gfortran conventions?" )
set_property(
    CACHE blas_fortran PROPERTY STRINGS
    "auto" "GNU gfortran conventions" "Intel ifort conventions" )

set( blas_int "auto" CACHE STRING
     "BLAS integer size: int (LP64) or int64_t (ILP64)" )
set_property(
    CACHE blas_int PROPERTY STRINGS
    "auto" "int (LP64)" "int64_t (ILP64)" )

set( blas_threaded "auto" CACHE STRING
     "Multi-threaded BLAS?" )
set_property(
    CACHE blas_threaded PROPERTY STRINGS
    "auto" "true" "false" )

#-----------------------------------
# LAPACK options
# todo: FLAME, others?
set( lapack "auto" CACHE STRING
     "LAPACK library to search for. Often, LAPACK is included in the BLAS library (e.g., -lopenblas contains both)." )
set_property(
    CACHE lapack PROPERTY STRINGS
    "auto" "generic" )

message( DEBUG "Settings:
CMAKE_VERSION          = ${CMAKE_VERSION}
CMAKE_INSTALL_PREFIX   = ${CMAKE_INSTALL_PREFIX}
CMAKE_BUILD_TYPE       = ${CMAKE_BUILD_TYPE}
BUILD_SHARED_LIBS      = ${BUILD_SHARED_LIBS}
BLA_VENDOR             = ${BLA_VENDOR}
blas                   = ${blas}
blas_fortran           = ${blas_fortran}
blas_int               = ${blas_int}
blas_threaded          = ${blas_threaded}
lapack                 = ${lapack}
build_tests            = ${build_tests}
color                  = ${color}
use_cmake_find_blas    = ${use_cmake_find_blas}
gpu_backend            = ${gpu_backend}
use_openmp             = ${use_openmp}
blaspp_is_project      = ${blaspp_is_project}
blaspp_                = ${blaspp_}
" )

#-------------------------------------------------------------------------------
# Enforce out-of-source build
string( TOLOWER "${CMAKE_CURRENT_SOURCE_DIR}" source_dir )
string( TOLOWER "${CMAKE_CURRENT_BINARY_DIR}" binary_dir )
if ("${source_dir}" STREQUAL "${binary_dir}")
    message( FATAL_ERROR
    "Compiling BLAS++ with CMake requires an out-of-source build. To proceed:
    rm -rf CMakeCache.txt CMakeFiles/   # delete files in ${CMAKE_CURRENT_SOURCE_DIR}
    mkdir build
    cd build
    cmake ..
    make" )
endif()

#-------------------------------------------------------------------------------
# Build library.
add_library(
    blaspp
    src/asum.cc
    src/axpy.cc
    src/batch_gemm.cc
    src/batch_hemm.cc
    src/batch_her2k.cc
    src/batch_herk.cc
    src/batch_symm.cc
    src/batch_syr2k.cc
    src/batch_syrk.cc
    src/batch_trmm.cc
    src/batch_trsm.cc
    src/copy.cc
    src/dot.cc
    src/gemm.cc
    src/gemv.cc
    src/ger.cc
    src/hemm.cc
    src/hemv.cc
    src/her.cc
    src/her2.cc
    src/her2k.cc
    src/herk.cc
    src/iamax.cc
    src/nrm2.cc
    src/rot.cc
    src/rotg.cc
    src/rotm.cc
    src/rotmg.cc
    src/scal.cc
    src/swap.cc
    src/symm.cc
    src/symv.cc
    src/syr.cc
    src/syr2.cc
    src/syr2k.cc
    src/syrk.cc
    src/trmm.cc
    src/trmv.cc
    src/trsm.cc
    src/trsv.cc
    src/version.cc
    src/device_batch_gemm.cc
    src/device_batch_gemm_group.cc
    src/device_batch_hemm.cc
    src/device_batch_her2k.cc
    src/device_batch_herk.cc
    src/device_batch_symm.cc
    src/device_batch_syr2k.cc
    src/device_batch_syrk.cc
    src/device_batch_trmm.cc
    src/device_batch_trsm.cc
    src/device_error.cc
    src/device_gemm.cc
    src/device_hemm.cc
    src/device_her2k.cc
    src/device_herk.cc
    src/device_queue.cc
    src/device_symm.cc
    src/device_syr2k.cc
    src/device_syrk.cc
    src/device_axpy.cc
    src/device_dot.cc
    src/device_nrm2.cc
    src/device_scal.cc
    src/device_swap.cc
    src/device_copy.cc
    src/device_trmm.cc
    src/device_trsm.cc
    src/device_utils.cc
    src/cublas_wrappers.cc
    src/rocblas_wrappers.cc
    src/onemkl_wrappers.cc
)

#-------------------------------------------------------------------------------
# CUDA support.
message( "" )
set( blaspp_use_cuda false )  # output in blasppConfig.cmake.in
if (gpu_backend MATCHES "^(auto|cuda)$")
    message( STATUS "${bold}Looking for CUDA${not_bold} (gpu_backend = ${gpu_backend})" )
    if (gpu_backend STREQUAL "cuda")
        find_package( CUDAToolkit REQUIRED )
    else()
        find_package( CUDAToolkit QUIET )
    endif()
    if (CUDAToolkit_FOUND)
        set( gpu_backend "cuda" )
        set( blaspp_defs_cuda_ "-DBLAS_HAVE_CUBLAS" )
        set( blaspp_use_cuda true )

        # Some platforms need these to be public libraries.
        target_link_libraries(
            blaspp PUBLIC CUDA::cudart CUDA::cublas )
        message( STATUS "${blue}Building CUDA support${plain}" )
    else()
        message( STATUS "${red}No CUDA support: CUDA not found${plain}" )
    endif()
else()
    message( STATUS "${red}No CUDA support: gpu_backend = ${gpu_backend}${plain}" )
endif()

#-------------------------------------------------------------------------------
# HIP/ROCm support.
message( "" )
set( blaspp_use_hip false )  # output in blasppConfig.cmake.in
if (NOT CUDAToolkit_FOUND
    AND gpu_backend MATCHES "^(auto|hip)$")

    message( STATUS "${bold}Looking for HIP/ROCm${not_bold} (gpu_backend = ${gpu_backend})" )
    if (gpu_backend STREQUAL "hip")
        find_package( rocblas REQUIRED )
    else()
        find_package( rocblas QUIET )
    endif()
    if (rocblas_FOUND)
        set( gpu_backend "hip" )
        set( blaspp_defs_hip_ "-DBLAS_HAVE_ROCBLAS" )
        set( blaspp_use_hip true )

        # Some platforms need these to be public libraries.
        target_link_libraries(
            blaspp PUBLIC roc::rocblas )
        message( STATUS "${blue}Building HIP/ROCm support${plain}" )
    else()
        message( STATUS "${red}No HIP/ROCm support: ROCm not found${plain}" )
    endif()
else()
    message( STATUS "${red}No HIP/ROCm support: gpu_backend = ${gpu_backend}${plain}" )
endif()

#-------------------------------------------------------------------------------
# SYCL support.
message( "" )
set( blaspp_use_sycl false )  # output in blasppConfig.cmake.in
# if cuda or hip were found gpu_backend was set appropriately
if (gpu_backend MATCHES "^(sycl|auto)$")

    message( STATUS "${bold}Looking for oneMKL-SYCL${not_bold} (gpu_backend = ${gpu_backend})" )
    if (TARGET MKL::MKL_DPCPP) # Search for MKL only if not already been found
        set( MKL_FOUND true )
    endif()
    if (NOT MKL_FOUND) # Search for MKL only if not already been found
        if (gpu_backend STREQUAL "sycl")
            find_package( MKL CONFIG REQUIRED QUIET HINTS "$ENV{MKL_ROOT}")
        else()
            find_package( MKL CONFIG QUIET HINTS "$ENV{MKL_ROOT}")
        endif()
    endif()
    # message(STATUS "Available targets: ${MKL_IMPORTED_TARGETS}")

    # Check if compiler supports the SYCL flag
    check_cxx_compiler_flag( "-fsycl" FSYCL_SUPPORT )

    # If oneMKL is found and the compiler supports SYCL then
    # enable oneMKL-SYCL-device support
    if (MKL_FOUND AND FSYCL_SUPPORT)
        set( gpu_backend "sycl" )
        set( blaspp_defs_sycl_ "-DBLAS_HAVE_SYCL;-DBLAS_FORTRAN_ADD_" )
        set( blaspp_use_sycl true )

        # Uncomment to use CMake FindBLAS using BLA_VENDOR
        # if (NOT BLA_VENDOR)
        #    set( BLA_VENDOR Intel10_64lp )
        # endif()

        target_compile_options( blaspp PUBLIC -fsycl )
        target_link_options( blaspp PUBLIC -fsycl )
        target_link_libraries( blaspp PUBLIC -lmkl_sycl -lsycl -lOpenCL )
        message( STATUS "${blue}Building oneMKL-SYCL device support${plain}" )
    elseif (gpu_backend STREQUAL "sycl")
        message( FATAL_ERROR "${red}SYCL compiler not found${plain}" )
    else()
        message( STATUS "${red}No oneMKL-SYCL device support: oneMKL or SYCL compiler not found${plain}" )
    endif()
else()
    message( STATUS "${red}No oneMKL-SYCL device support: gpu_backend = ${gpu_backend}${plain}" )
endif()

#-------------------------------------------------------------------------------
# Clean stale defines.h from Makefile-based build.
message( "" )
file( REMOVE "${CMAKE_CURRENT_SOURCE_DIR}/include/blas/defines.h" )

# Include directory.
# During build it's {source}/include; after install it's {prefix}/include.
target_include_directories(
    blaspp
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>"  # defines.h

=== test/CMakeLists.txt ===
# Copyright (c) 2017-2023, University of Tennessee. All rights reserved.
# SPDX-License-Identifier: BSD-3-Clause
# This program is free software: you can redistribute it and/or modify it under
# the terms of the BSD 3-Clause license. See the accompanying LICENSE file.

# Can't build testers if CBLAS, LAPACK, or TestSweeper are not found.
if (NOT blaspp_cblas_found)
    message( WARNING "CBLAS not found; tester cannot be built." )
    return()
endif()

if (NOT LAPACK_FOUND)
    message( WARNING "LAPACK not found; tester cannot be built." )
    return()
endif()

# Search for TestSweeper library, if not already included (e.g., in SLATE).
message( STATUS "${bold}Checking for TestSweeper library${not_bold}" )
if (NOT TARGET testsweeper)
    find_package( testsweeper QUIET )
    if (testsweeper_FOUND)
        message( "   ${blue}Found TestSweeper library: ${testsweeper_DIR}${plain}" )
        message( "" )
    else()
        set( url "https://github.com/icl-utk-edu/testsweeper" )
        set( tag "v2023.11.05" )
        message( "" )
        message( "---------- TestSweeper" )
        message( STATUS "Fetching TestSweeper ${tag} from ${url}" )
        include( FetchContent )
        FetchContent_Declare( testsweeper GIT_REPOSITORY "${url}"
                                          GIT_TAG "${tag}" )
        FetchContent_MakeAvailable( testsweeper )
        message( "---------- TestSweeper done" )
        message( "" )
    endif()
else()
    message( "   ${blue}TestSweeper already included${plain}" )
endif()

#-------------------------------------------------------------------------------
set( tester "${blaspp_}tester" )
add_executable(
    ${tester}
    test.cc
    test_util.cc
    test_asum.cc
    test_axpy.cc
    test_batch_gemm.cc
    test_batch_hemm.cc
    test_batch_her2k.cc
    test_batch_herk.cc
    test_batch_symm.cc
    test_batch_syr2k.cc
    test_batch_syrk.cc
    test_batch_trmm.cc
    test_batch_trsm.cc
    test_copy.cc
    test_dot.cc
    test_dotu.cc
    test_error.cc
    test_gemm.cc
    test_gemv.cc
    test_ger.cc
    test_geru.cc
    test_hemm.cc
    test_hemv.cc
    test_her.cc
    test_her2.cc
    test_her2k.cc
    test_herk.cc
    test_iamax.cc
    test_max.cc
    test_memcpy.cc
    test_memcpy_2d.cc
    test_nrm2.cc
    test_rot.cc
    test_rotg.cc
    test_rotm.cc
    test_rotmg.cc
    test_scal.cc
    test_swap.cc
    test_symm.cc
    test_symv.cc
    test_syr.cc
    test_syr2.cc
    test_syr2k.cc
    test_syrk.cc
    test_trmm.cc
    test_trmv.cc
    test_trsm.cc
    test_trsv.cc
    cblas_wrappers.cc
    lapack_wrappers.cc
    test_batch_gemm_device.cc
    test_batch_hemm_device.cc
    test_batch_her2k_device.cc
    test_batch_herk_device.cc
    test_schur_gemm.cc
    test_batch_symm_device.cc
    test_batch_syr2k_device.cc
    test_batch_syrk_device.cc
    test_batch_trmm_device.cc
    test_batch_trsm_device.cc
    test_axpy_device.cc
    test_dot_device.cc
    test_dotu_device.cc
    test_nrm2_device.cc
    test_scal_device.cc
    test_swap_device.cc
    test_copy_device.cc
    test_gemm_device.cc
    test_hemm_device.cc
    test_her2k_device.cc
    test_herk_device.cc
    test_symm_device.cc
    test_syr2k_device.cc
    test_syrk_device.cc
    test_trmm_device.cc
    test_trsm_device.cc
)

# C++11 is inherited from blaspp, but disabling extensions is not.
set_target_properties( ${tester} PROPERTIES CXX_EXTENSIONS false )

target_link_libraries(
    ${tester}
    testsweeper
    blaspp
    ${blaspp_cblas_libraries}
    ${lapack_libraries_}
)

target_include_directories(
    ${tester}
    PRIVATE
        "${blaspp_cblas_include}"
)

# Copy run_tests script to build directory.
add_custom_command(
    TARGET ${tester} POST_BUILD
    COMMAND
        cp ${CMAKE_CURRENT_SOURCE_DIR}/run_tests.py
           ${CMAKE_CURRENT_BINARY_DIR}/run_tests.py
)

if (blaspp_is_project)
    add_custom_target(
        "check"
        COMMAND
            python3 run_tests.py --quick
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
endif()

=== debian/changelog ===
blaspp (2023.11.05-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Dec 2023 18:20:58 +0100

blaspp (2023.08.25-2) unstable; urgency=medium

  * debian/patches/reproducible-build.patch: New patch, making the build
    reproducible, by Chris Lamb (Closes: #1053263).

 -- Michael Banck <mbanck@debian.org>  Sat, 30 Sep 2023 16:34:16 +0200

blaspp (2023.08.25-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Tue, 12 Sep 2023 14:37:38 +0530

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- 					\
		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
		-DBUILD_SHARED_LIBS=NO

## blaspp 2024.05.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,9 +15,15 @@
 
 project(
     blaspp
-    VERSION 2023.11.05
+    VERSION 2024.05.31
     LANGUAGES CXX
 )
+
+# See notes in GNUmakefile about using abi-compliance-checker.
+# soversion is major ABI version.
+set( abi_version 1.0.0 )
+string( REPLACE "." ";" abi_list "${abi_version}" )
+list( GET abi_list 0 soversion )
 
 include( CheckCXXCompilerFlag )
 
@@ -147,6 +153,8 @@
 use_openmp             = ${use_openmp}
 blaspp_is_project      = ${blaspp_is_project}
 blaspp_                = ${blaspp_}
+abi_version            = ${abi_version}
+soversion              = ${soversion}
 " )
 
 #-------------------------------------------------------------------------------
@@ -207,7 +215,9 @@
     src/trmv.cc
     src/trsm.cc
     src/trsv.cc
+    src/util.cc
     src/version.cc
+
     src/device_batch_gemm.cc
     src/device_batch_gemm_group.cc
     src/device_batch_hemm.cc
@@ -348,11 +358,3 @@
 #-------------------------------------------------------------------------------
 # Clean stale defines.h from Makefile-based build.
 message( "" )
-file( REMOVE "${CMAKE_CURRENT_SOURCE_DIR}/include/blas/defines.h" )
-
-# Include directory.
-# During build it's {source}/include; after install it's {prefix}/include.
-target_include_directories(
-    blaspp
-    PUBLIC
-        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>"  # defines.h

=== examples/CMakeLists.txt ===
# Copyright (c) 2017-2023, University of Tennessee. All rights reserved.
# SPDX-License-Identifier: BSD-3-Clause
# This program is free software: you can redistribute it and/or modify it under
# the terms of the BSD 3-Clause license. See the accompanying LICENSE file.

# CXX compiler must match the one used to compiler BLAS++.
# Set it in your environment.

cmake_minimum_required( VERSION 3.8 )

project(
    blaspp_example
    LANGUAGES CXX
)

#-------------------------------------------------------------------------------
# Enforce out-of-source build
string( TOLOWER "${CMAKE_CURRENT_SOURCE_DIR}" source_dir )
string( TOLOWER "${CMAKE_CURRENT_BINARY_DIR}" binary_dir )
if ("${source_dir}" STREQUAL "${binary_dir}")
    message( FATAL_ERROR
    "Compiling with CMake requires an out-of-source build. To proceed:
    rm -rf CMakeCache.txt CMakeFiles/   # delete files in ${CMAKE_CURRENT_SOURCE_DIR}
    mkdir build
    cd build
    cmake ..
    make" )
endif()

#-------------------------------------------------------------------------------
find_package( blaspp REQUIRED )

#--------------------
add_executable(
    example_gemm
    example_gemm.cc
)
target_link_libraries(
    example_gemm
    blaspp
)

#--------------------
add_executable(
    example_util
    example_util.cc
)
target_link_libraries(
    example_util
    blaspp
)

#-------------------------------------------------------------------------------
# CTest

# Get precisions to test. See .github/workflows/test.sh
set( test_args $ENV{test_args} )
if (NOT test_args)
    set( test_args "s d c z" )
endif()
string( REPLACE " " ";" test_args ${test_args} ) # convert to list

enable_testing()
add_test( NAME example_gemm COMMAND ./example_gemm ${test_args} )
add_test( NAME example_util COMMAND ./example_util ${test_args} )

=== examples/Makefile ===
# Copyright (c) 2017-2023, University of Tennessee. All rights reserved.
# SPDX-License-Identifier: BSD-3-Clause
# This program is free software: you can redistribute it and/or modify it under
# the terms of the BSD 3-Clause license. See the accompanying LICENSE file.

# CXX compiler must match the one used to compiler BLAS++.
# Set it in your environment or here.
# Sadly, pkg-config doesn't provide a way to query CXX,
# CXXFLAGS (only cflags), CPPFLAGS, or LDFLAGS.

#-------------------------------------------------------------------------------
# Set CXXFLAGS and LIBS
pkg_exists := $(shell pkg-config --exists blaspp; echo $$?)
ifeq ($(pkg_exists),0)

  # Get flags from pkg-config.
  CXX      = $(shell pkg-config --variable CXX blaspp)
  CXXFLAGS = $(shell pkg-config --cflags blaspp)
  LIBS     = $(shell pkg-config --libs   blaspp)

else
  $(warning WARNING: pkg-config couldn't find blaspp. Using hard-coded flags in Makefile.)

  # BLAS++ not in pkg-config.
  # Here's a hard-coded example using OpenBLAS.
  CXXFLAGS = -I/usr/local/blaspp/include -std=c++11
  LIBS     = -L/usr/local/blaspp/lib$(LIB_SUFFIX) -lblaspp -lopenblas

endif

#-------------------------------------------------------------------------------
# Rules

exe = example_gemm example_util
run = ${addsuffix .run, ${exe}}
txt = ${addsuffix .txt, ${exe}}

.DELETE_ON_ERROR:
.SECONDARY:
.SUFFIXES:
.DEFAULT_GOAL := all
.PRECIOUS: ${txt}

# Serialize everything so that `make test` runs in serial.
.NOTPARALLEL:

all: ${exe}

%: %.o
	$(CXX) -o $@ $^ $(LIBS)

%.o: %.cc
	$(CXX) $(CXXFLAGS) -c -o $@ $<

clean:
	-rm -f ${exe} ${txt} *.o *.d

# CMake uses `make test`, GNU autotools uses `make check`; allow both.
test: check
check: ${run}

# Run example, but don't save results; %.run is dummy filename.
%.run: %
	@echo "----------------------------------------------------------------------"
	./$< ${test_args}

# Run example and save result in .txt file.
txt: ${txt}
%.txt: %
	./$< ${test_args} > $@

#-------------------------------------------------------------------------------
# Debugging
echo:
	@echo "PKG_CONFIG_PATH $(PKG_CONFIG_PATH)"
	@echo "pkg_exists $(pkg_exists)"
	@echo "CXX        $(CXX)"
	@echo "CXXFLAGS   $(CXXFLAGS)"
	@echo "LIBS       $(LIBS)"
	@echo
	@echo "exe       $(exe)"
	@echo "run       $(run)"
	@echo "txt       $(txt)"

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
         message( "" )
     else()
         set( url "https://github.com/icl-utk-edu/testsweeper" )
-        set( tag "v2023.11.05" )
+        set( tag "v2024.05.31" )
         message( "" )
         message( "---------- TestSweeper" )
         message( STATUS "Fetching TestSweeper ${tag} from ${url}" )

=== debian/changelog ===
blaspp (2024.05.31-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sun, 30 Jun 2024 16:00:55 +0200

## blaspp 2024.10.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 project(
     blaspp
-    VERSION 2024.05.31
+    VERSION 2024.10.26
     LANGUAGES CXX
 )

=== debian/changelog ===
blaspp (2024.10.26-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/reproducible-build.patch: Removed, applied upstream. 

 -- Michael Banck <mbanck@debian.org>  Sun, 09 Mar 2025 18:51:43 +0100

=== debian/control ===
Source: blaspp
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               libblas-dev
Standards-Version: 4.5.1
Homepage: https://github.com/icl-utk-edu/blaspp
Vcs-Browser: https://salsa.debian.org/debichem-team/blaspp
Vcs-Git: https://salsa.debian.org/debichem-team/blaspp.git

Package: libblaspp-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ API for the Basic Linear Algebra Subroutines (development files)
 The Basic Linear Algebra Subprograms (BLAS) have been around for many decades
 and serve as the de facto standard for performance-portable and numerically
 robust implementation of essential linear algebra functionality. Originally,
 they were written in Fortran, and later furnished with a C API (CBLAS).
 .
 The objective of BLAS++ is to provide a convenient, performance oriented API
 for development in the C++ language, that, for the most part, preserves
 established conventions, while, at the same time, takes advantages of modern
 C++ features, such as: namespaces, templates, exceptions, etc.
 .
 This package contains the static libraries and the header files.

=== debian/watch ===
version=3
https://github.com/icl-utk-edu/blaspp/tags .*/v([\d.]+)\.tar\.(?:bz2|gz)

## blaspp 2025.05.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,23 +5,24 @@
 #
 # CMake script for BLAS++ library.
 
-cmake_minimum_required( VERSION 3.17 )
+cmake_minimum_required( VERSION 3.21 )
 # 3.1  target_compile_features
 # 3.8  target_compile_features( cxx_std_17 )
 # 3.14 install( LIBRARY DESTINATION lib ) default
 # 3.15 $<$COMPILE_LANG_AND_ID  # optional
 # 3.15 message DEBUG, string REPEAT
 # 3.17 find_package( CUDAToolkit )
+# 3.21 enable_language( HIP ) support
 
 project(
     blaspp
-    VERSION 2024.10.26
+    VERSION 2025.05.28
     LANGUAGES CXX
 )
 
 # See notes in GNUmakefile about using abi-compliance-checker.
 # soversion is major ABI version.
-set( abi_version 1.0.0 )
+set( abi_version 2.0.0 )
 string( REPLACE "." ";" abi_list "${abi_version}" )
 list( GET abi_list 0 soversion )
 
@@ -61,6 +62,7 @@
 
 # After color.
 include( "cmake/util.cmake" )
+include( "cmake/config.cmake" )
 
 # Recognize CTest's BUILD_TESTING flag. (Quotes required.)
 if (NOT "${BUILD_TESTING}" STREQUAL "")
@@ -105,8 +107,8 @@
      "BLAS library to search for" )
 set_property(
     CACHE blas PROPERTY STRINGS
-    "auto" "Apple Accelerate" "Cray LibSci" "IBM ESSL"
-    "Intel MKL" "OpenBLAS" "AMD ACML" "generic" )
+    "auto" "AMD AOCL" "Apple Accelerate" "BLIS" "Cray LibSci" "IBM ESSL"
+    "Intel MKL" "OpenBLAS" "generic" )
 
 set( blas_fortran "auto" CACHE STRING
      "For Intel MKL: use Intel ifort or GNU gfortran conventions?" )
@@ -169,6 +171,131 @@
     cd build
     cmake ..
     make" )
+endif()
+
+#-------------------------------------------------------------------------------
+# Load the CUDA language and packages.
+message( "" )
+set( blaspp_use_cuda false )  # output in blasppConfig.cmake.in
+if (gpu_backend MATCHES "^(auto|cuda)$")
+    message( STATUS "${bold}Looking for CUDA${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (gpu_backend STREQUAL "cuda")
+        find_package( CUDAToolkit REQUIRED )
+    else()
+        find_package( CUDAToolkit QUIET )
+    endif()
+    if (CUDAToolkit_FOUND)
+        set( gpu_backend "cuda" )
+        set( blaspp_defs_cuda_ "-DBLAS_HAVE_CUBLAS" )
+        set( blaspp_use_cuda true )
+
+        # Set CUDA architecture _before_ enable_language, otherwise we get some
+        # default CMake value seemingly unrelated to the native GPU, e.g., 52.
+        #
+        # See nvcc --help, in section --gpu-architecture
+        # 30  Kepler
+        # 50  Maxwell
+        # 60  Pascal
+        # 70  Volta
+        # 75  Turing
+        # 80  Ampere
+        # 90  Hopper
+        # 100 Blackwell ?
+        #
+        if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.24)
+            set( arch "native" )
+        else()
+            set( arch "70" )  # Volta
+        endif()
+        set( CMAKE_CUDA_ARCHITECTURES "${arch}" CACHE STRING
+            "CUDA architectures, as semi-colon separated list of (mostly) 2-3 digit numbers, e.g., 60;70;80 for Pascal, Volta, Ampere" )
+        set_property( CACHE CMAKE_CUDA_ARCHITECTURES PROPERTY STRINGS
+                    native all all-major 30 50 60 70 75 80 90 )
+        enable_language(CUDA)
+        message( STATUS "${blue}Building CUDA support${plain}" )
+    else()
+        message( STATUS "${red}No CUDA support: CUDA not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping CUDA search: gpu_backend = ${gpu_backend}${plain}" )
+endif()
+
+#-------------------------------------------------------------------------------
+# Load HIP language and packages.
+message( "" )
+set( blaspp_use_hip false )  # output in blasppConfig.cmake.in
+if (NOT CUDAToolkit_FOUND
+    AND gpu_backend MATCHES "^(auto|hip)$")
+
+    message( STATUS "${bold}Looking for HIP/ROCm${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (gpu_backend STREQUAL "hip")
+        find_package( hip REQUIRED )
+        find_package( rocblas REQUIRED )
+    else()
+        find_package( rocblas QUIET )
+    endif()
+    if (rocblas_FOUND)
+        set( gpu_backend "hip" )
+        set( blaspp_defs_hip_ "-DBLAS_HAVE_ROCBLAS" )
+        set( blaspp_use_hip true )
+
+        # For ROCm >= 3.5, wipe hip-clang specific interface options which are propagated
+        set_target_properties( hip::device PROPERTIES INTERFACE_COMPILE_OPTIONS "-fPIC" )
+        set_target_properties( hip::device PROPERTIES INTERFACE_LINK_LIBRARIES "hip::host" )
+
+        enable_language( HIP )
+        message( STATUS "${blue}Building HIP/ROCm support${plain}" )
+    else()
+        message( STATUS "${red}No HIP/ROCm support: ROCm not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping HIP/ROCm search: gpu_backend = ${gpu_backend}${plain}" )
+endif()
+
+
+#-------------------------------------------------------------------------------
+# SYCL support.
+message( "" )
+set( blaspp_use_sycl false )  # output in blasppConfig.cmake.in
+# if cuda or hip were found gpu_backend was set appropriately
+if (gpu_backend MATCHES "^(auto|sycl)$")
+
+    message( STATUS "${bold}Looking for oneMKL-SYCL${not_bold} (gpu_backend = ${gpu_backend})" )
+    if (TARGET MKL::MKL_DPCPP) # Search for MKL only if not already been found
+        set( MKL_FOUND true )
+    endif()
+    if (NOT MKL_FOUND) # Search for MKL only if not already been found
+        if (gpu_backend STREQUAL "sycl")
+            find_package( MKL CONFIG REQUIRED QUIET HINTS "$ENV{MKL_ROOT}")
+        else()
+            find_package( MKL CONFIG QUIET HINTS "$ENV{MKL_ROOT}")
+        endif()
+    endif()
+    # message(STATUS "Available targets: ${MKL_IMPORTED_TARGETS}")
+
+    # Check if compiler supports the SYCL flag
+    check_cxx_compiler_flag( "-fsycl" FSYCL_SUPPORT )
+
+    # If oneMKL is found and the compiler supports SYCL then
+    # enable oneMKL-SYCL-device support
+    if (MKL_FOUND AND FSYCL_SUPPORT)
+        set( gpu_backend "sycl" )
+        set( blaspp_defs_sycl_ "-DBLAS_HAVE_SYCL;-DBLAS_FORTRAN_ADD_" )
+        set( blaspp_use_sycl true )
+
+        # Uncomment to use CMake FindBLAS using BLA_VENDOR
+        # if (NOT BLA_VENDOR)
+        #    set( BLA_VENDOR Intel10_64lp )
+        # endif()
+
+        message( STATUS "${blue}Building oneMKL-SYCL device support${plain}" )
+    elseif (gpu_backend STREQUAL "sycl")
+        message( FATAL_ERROR "${red}SYCL compiler not found${plain}" )
+    else()
+        message( STATUS "${red}No oneMKL-SYCL device support: oneMKL or SYCL compiler not found${plain}" )
+    endif()
+else()
+    message( STATUS "${red}Skipping oneMKL-SYCL search: gpu_backend = ${gpu_backend}${plain}" )
 endif()
 
 #-------------------------------------------------------------------------------
@@ -219,142 +346,3 @@
     src/version.cc
 
     src/device_batch_gemm.cc
-    src/device_batch_gemm_group.cc
-    src/device_batch_hemm.cc
-    src/device_batch_her2k.cc
-    src/device_batch_herk.cc
-    src/device_batch_symm.cc
-    src/device_batch_syr2k.cc
-    src/device_batch_syrk.cc
-    src/device_batch_trmm.cc
-    src/device_batch_trsm.cc
-    src/device_error.cc
-    src/device_gemm.cc
-    src/device_hemm.cc
-    src/device_her2k.cc
-    src/device_herk.cc
-    src/device_queue.cc
-    src/device_symm.cc
-    src/device_syr2k.cc
-    src/device_syrk.cc
-    src/device_axpy.cc
-    src/device_dot.cc
-    src/device_nrm2.cc
-    src/device_scal.cc
-    src/device_swap.cc
-    src/device_copy.cc
-    src/device_trmm.cc
-    src/device_trsm.cc
-    src/device_utils.cc
-    src/cublas_wrappers.cc
-    src/rocblas_wrappers.cc
-    src/onemkl_wrappers.cc
-)
-
-#-------------------------------------------------------------------------------
-# CUDA support.
-message( "" )
-set( blaspp_use_cuda false )  # output in blasppConfig.cmake.in
-if (gpu_backend MATCHES "^(auto|cuda)$")
-    message( STATUS "${bold}Looking for CUDA${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (gpu_backend STREQUAL "cuda")
-        find_package( CUDAToolkit REQUIRED )
-    else()
-        find_package( CUDAToolkit QUIET )
-    endif()
-    if (CUDAToolkit_FOUND)
-        set( gpu_backend "cuda" )
-        set( blaspp_defs_cuda_ "-DBLAS_HAVE_CUBLAS" )
-        set( blaspp_use_cuda true )
-
-        # Some platforms need these to be public libraries.
-        target_link_libraries(
-            blaspp PUBLIC CUDA::cudart CUDA::cublas )
-        message( STATUS "${blue}Building CUDA support${plain}" )
-    else()
-        message( STATUS "${red}No CUDA support: CUDA not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No CUDA support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# HIP/ROCm support.
-message( "" )
-set( blaspp_use_hip false )  # output in blasppConfig.cmake.in
-if (NOT CUDAToolkit_FOUND
-    AND gpu_backend MATCHES "^(auto|hip)$")
-
-    message( STATUS "${bold}Looking for HIP/ROCm${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (gpu_backend STREQUAL "hip")
-        find_package( rocblas REQUIRED )
-    else()
-        find_package( rocblas QUIET )
-    endif()
-    if (rocblas_FOUND)
-        set( gpu_backend "hip" )
-        set( blaspp_defs_hip_ "-DBLAS_HAVE_ROCBLAS" )
-        set( blaspp_use_hip true )
-
-        # Some platforms need these to be public libraries.
-        target_link_libraries(
-            blaspp PUBLIC roc::rocblas )
-        message( STATUS "${blue}Building HIP/ROCm support${plain}" )
-    else()
-        message( STATUS "${red}No HIP/ROCm support: ROCm not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No HIP/ROCm support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# SYCL support.
-message( "" )
-set( blaspp_use_sycl false )  # output in blasppConfig.cmake.in
-# if cuda or hip were found gpu_backend was set appropriately
-if (gpu_backend MATCHES "^(sycl|auto)$")
-
-    message( STATUS "${bold}Looking for oneMKL-SYCL${not_bold} (gpu_backend = ${gpu_backend})" )
-    if (TARGET MKL::MKL_DPCPP) # Search for MKL only if not already been found
-        set( MKL_FOUND true )
-    endif()
-    if (NOT MKL_FOUND) # Search for MKL only if not already been found
-        if (gpu_backend STREQUAL "sycl")
-            find_package( MKL CONFIG REQUIRED QUIET HINTS "$ENV{MKL_ROOT}")
-        else()
-            find_package( MKL CONFIG QUIET HINTS "$ENV{MKL_ROOT}")
-        endif()
-    endif()
-    # message(STATUS "Available targets: ${MKL_IMPORTED_TARGETS}")
-
-    # Check if compiler supports the SYCL flag
-    check_cxx_compiler_flag( "-fsycl" FSYCL_SUPPORT )
-
-    # If oneMKL is found and the compiler supports SYCL then
-    # enable oneMKL-SYCL-device support
-    if (MKL_FOUND AND FSYCL_SUPPORT)
-        set( gpu_backend "sycl" )
-        set( blaspp_defs_sycl_ "-DBLAS_HAVE_SYCL;-DBLAS_FORTRAN_ADD_" )
-        set( blaspp_use_sycl true )
-
-        # Uncomment to use CMake FindBLAS using BLA_VENDOR
-        # if (NOT BLA_VENDOR)
-        #    set( BLA_VENDOR Intel10_64lp )
-        # endif()
-
-        target_compile_options( blaspp PUBLIC -fsycl )
-        target_link_options( blaspp PUBLIC -fsycl )
-        target_link_libraries( blaspp PUBLIC -lmkl_sycl -lsycl -lOpenCL )
-        message( STATUS "${blue}Building oneMKL-SYCL device support${plain}" )
-    elseif (gpu_backend STREQUAL "sycl")
-        message( FATAL_ERROR "${red}SYCL compiler not found${plain}" )
-    else()
-        message( STATUS "${red}No oneMKL-SYCL device support: oneMKL or SYCL compiler not found${plain}" )
-    endif()
-else()
-    message( STATUS "${red}No oneMKL-SYCL device support: gpu_backend = ${gpu_backend}${plain}" )
-endif()
-
-#-------------------------------------------------------------------------------
-# Clean stale defines.h from Makefile-based build.
-message( "" )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
         message( "" )
     else()
         set( url "https://github.com/icl-utk-edu/testsweeper" )
-        set( tag "v2024.05.31" )
+        set( tag "v2025.05.28" )
         message( "" )
         message( "---------- TestSweeper" )
         message( STATUS "Fetching TestSweeper ${tag} from ${url}" )
@@ -57,12 +57,10 @@
     test_batch_trsm.cc
     test_copy.cc
     test_dot.cc
-    test_dotu.cc
     test_error.cc
     test_gemm.cc
     test_gemv.cc
     test_ger.cc
-    test_geru.cc
     test_hemm.cc
     test_hemv.cc
     test_her.cc
@@ -102,10 +100,15 @@
     test_batch_syrk_device.cc
     test_batch_trmm_device.cc
     test_batch_trsm_device.cc
+    test_asum_device.cc
     test_axpy_device.cc
     test_dot_device.cc
-    test_dotu_device.cc
+    test_iamax_device.cc
     test_nrm2_device.cc
+    test_rot_device.cc
+    test_rotg_device.cc
+    test_rotm_device.cc
+    test_rotmg_device.cc
     test_scal_device.cc
     test_swap_device.cc
     test_copy_device.cc

=== debian/changelog ===
blaspp (2025.05.28-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Build-Depends): Added liblapack-dev, libtestsweeper-dev and
    python3.
  * debian/rules (override_dh_auto_build): Work-around spurious link error.

 -- Michael Banck <mbanck@debian.org>  Tue, 30 Dec 2025 12:49:40 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,10 @@
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: cmake,
                debhelper (>= 11),
-               libblas-dev
+               libblas-dev,
+               liblapack-dev,
+               libtestsweeper-dev (>= 2025.05.28-1),
+               python3
 Standards-Version: 4.5.1
 Homepage: https://github.com/icl-utk-edu/blaspp
 Vcs-Browser: https://salsa.debian.org/debichem-team/blaspp

=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,10 @@
 	dh_auto_configure -- 					\
 		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
 		-DBUILD_SHARED_LIBS=NO
+
+override_dh_auto_build:
+	-dh_auto_build
+	dh_auto_configure -- 					\
+		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}		\
+		-DBUILD_SHARED_LIBS=NO
+	dh_auto_build
